#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <math.h>
#include <allegro.h>
#include "data1.h"

#define WIDTH 320
#define HEIGHT 200

unsigned char sine_table[256];
unsigned char dbuffer[WIDTH*HEIGHT];

BITMAP *buffer1;
PALETTE pal;
DATAFILE *data;

void plasma()

{
   int pl1,pl2,pl3,pl4;
   int x,y,offs;

   static int inpl1=563,inpl2=233,inpl3=4325,inpl4=312556;

   inpl1+=rand()%10;

   inpl2-=rand()%10;

   inpl3+=rand()%10;

   inpl4-=rand()%10;

   pl1=inpl1;

   pl2=inpl2;

   pl3=inpl3;

   pl4=inpl4;

   offs=0;

   for (y=0;y<HEIGHT;y++)

   {

      pl1=inpl1;

      pl2=inpl2;

      for (x=0;x<WIDTH;x++)

      {

         dbuffer[offs++]=sine_table[pl1&255]+sine_table[pl2&255]+sine_table[pl3&255]+sine_table[pl4&255];

         pl1+=3;

         pl2-=4;

      }

      pl3+=2;

      pl4+=5;



   }

}

init_sin()
{
 int i;

 for (i=0; i<256; i++)
 {
  sine_table[i]=128+(sin(i*(6.28318531/256))*256);
 }
}

void initialise_allegro()
{ 
 allegro_init(); 
 set_gfx_mode(GFX_AUTODETECT, 320, 200, 0, 0);  
 buffer1=create_bitmap(320,200);
 set_palette(pal); 
 install_keyboard();
 install_timer();
 data=load_datafile("data1.dat");
 set_palette(data[pal1].dat);
}

void plas_start()
{
 plasma();
 memcpy(buffer1->line[0], dbuffer, 64000); 
 vsync();
 blit(buffer1,screen,0,0,0,0,320,200);
}

void main()
{
    initialise_allegro();
    init_sin();
    while(!key[KEY_ESC])
    {
     plas_start();
    }
    exit(0);
}
